//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/Error/Basic.h,v $
// $Id: Basic.h,v 1.5 2004/03/15 20:58:46 ah Exp $
//
// Description: basic error class
//
//---------------------------------------------------------------------------

#ifndef AH_ERROR_BASIC_H		// prevent multiple includes
#define AH_ERROR_BASIC_H

// --- forward declarations ---

// --- necessary includes ---

#include <AH/Error/Class.h>

// --- types and classes ---

BEGIN_NAMESPACE(AH)


/**
   ErrorBasic is a simple basic class for error handling. All
   other error classes should be derived from this class.

   Please include <Error/Basic.h>.
*/
/// simple basic error class
class ErrorBasic: public ErrorClass
{
  public:
    /// default constructor
    ErrorBasic () : msg("") {};
    /// constructor
    ErrorBasic (const string& m) : msg(m) {};
    /// copy constructor
    ErrorBasic(const ErrorBasic& src) : msg(src.msg) {}
    /// assignment operator
    const ErrorBasic& operator= (const ErrorBasic& src)
        { if (this != &src) msg = src.msg; return *this; }
    /// destructor
    virtual ~ErrorBasic () throw() {}
    
    // manipulating functions:
    /// add string before error message:
    void addHead(const string& head)
	{ msg = head + msg; }
    /// add string behind error message:
    void addTail(const string& tail)
	{ msg += tail; }

    // access functions:
    /// return error message
    virtual string getMsg() const { return msg; }

  protected:
    string msg;
  private:
}; // end of class ErrorBasic


END_NAMESPACE

#endif // AH_ERROR_BASIC_H
//**********************************************************************
//*			     E N D   O F   F I L E                     *
//**********************************************************************
