//---------------------------------------------------------------------------
// Copyright 1997 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/Etech/Amplifier.h,v $
// $Id: Amplifier.h,v 1.7 2001/10/05 23:44:27 ah Exp $
//
//---------------------------------------------------------------------------

#ifndef ETECH_AMPLIFIER_H	// prevent multiple includes
#define ETECH_AMPLIFIER_H

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/Types.h>

USING_NAMESPACE(Ah)
BEGIN_NAMESPACE(Ah)

// --- forward declarations ---

class Impedance;

// --- types and classes ---


/// pure virtual generic amplifier base class
/**
 {\tt Amplifier} is a pure virtual amplifier base class which uses an
 operational amplifer. It can be used both in DC (direct current) and in 
 AC (alternate current) applications.
 */
class Amplifier
{
  public:
    /// destructor:
    virtual ~Amplifier() {}

    /// get amplification at frequency {\tt freq}
    virtual Cplx getA(Dbl freq) = 0;

    /// get amplification at frequency {\tt freq} with {\tt load}
    virtual Cplx getA(Dbl freq, const Impedance& load) = 0;

}; // class Amplifier


// --- name space ---

END_NAMESPACE

#endif // ETECH_AMPLIFIER_H
