//---------------------------------------------------------------------------
// Copyright 1997 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/Etech/TransFollow.h,v $
// $Id: TransFollow.h,v 1.5 2001/10/05 23:44:27 ah Exp $
//
//---------------------------------------------------------------------------

#ifndef ETECH_TRANSFOLLOW_H	// prevent multiple includes
#define ETECH_TRANSFOLLOW_H

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Etech/Voltage.h>
#include <AH/Etech/Current.h>

USING_NAMESPACE(Ah)
BEGIN_NAMESPACE(Ah)

// --- forward declarations ---

// --- types and classes ---


class Transistor;
class Impedance;


/// represents a generic transistor follower
/**
 {\tt TransistorFollower} is an impedance buffer using a transistor in
 follower mode.
 */
class TransistorFollower
{
 public:
    /// constructor
    TransistorFollower(Transistor& t, const Impedance& load)
	: T(t), Load(load), cashedUs(0), cashedIc(0){}
    /// destructor
    ~TransistorFollower() {}

    /// return current through load
    Current getIload(const Voltage& Us);
    /// return voltage at load
    Voltage getUload(const Voltage& Us);

 private:
    Transistor&		T;
    const Impedance&	Load;
    Voltage		cashedUs;
    Current		cashedIc;
}; // class TransistorFollower


END_NAMESPACE

#endif // ETECH_TRANSFOLLOW_H
