//---------------------------------------------------------------------------
// Copyright 1999 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file `COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/IO/Error.h,v $
// $Id: Error.h,v 1.2 2004/03/15 20:58:09 ah Exp $
//
// Description: 
//
//---------------------------------------------------------------------------

#ifndef AH_IO_ERROR_H		// prevent multiple includes
#define AH_IO_ERROR_H

// --- forward declarations ---

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Error/Basic.h>
USING_NAMESPACE(AH)

// --- types and classes ---

BEGIN_NAMESPACE(AH)

/// represents any Input/Output error
/**
   <tt>AH::ErrorIO</tt> represents any Input/Output error.

   Please include <em>AH/.h</em>.
 */
class ErrorIO: public ErrorBasic
{
  public:
    /// default constructor
    ErrorIO() : ErrorBasic("IO error") {}
    /// constructor
    ErrorIO(const string& m) : ErrorBasic(m) {};
    /// copy constructor
    ErrorIO(const ErrorIO& src) : ErrorBasic(src) {}
    /// assignment operator:
    const ErrorIO& operator=(const ErrorIO& src)
	{
	    if (&src != this)
	    {
		ErrorBasic::operator=(src);
	    }
	    return *this;
	}
    /// destructor
    virtual ~ErrorIO() throw () {}
};

END_NAMESPACE

#endif // !AH_IO_ERROR_H














