//---------------------------------------------------------------------------
// Copyright 2004 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/include/AH/IO/Midi/SysExCmd.h,v $
// $Id: SysExCmd.h,v 1.1 2004/03/05 22:53:04 ah Exp $
//
// Description: class representing a System Exclusive MIDI command. 
//
//---------------------------------------------------------------------------

#ifndef AH_IO_MIDI_SYS_EX_CMD_H		// prevent multiple includes
#define AH_IO_MIDI_SYS_EX_CMD_H

// --- forward declarations ---

// --- necessary includes ---

#include <AH/Config/Platform.h>
#include <AH/Config/Types.h>
#include <AH/IO/Midi/RawCmd.h>
USING_NAMESPACE(AH)

// --- types and classes ---

BEGIN_NAMESPACE(AH)

// represents a System Exclusive MIDI command
class IOMidiSysExCmd
{
 public:
    //-------------------
    // con-/destructors:
    //-------------------
    
    /// constructor for System Exclusive MIDI command 
    IOMidiSysExCmd
    (
	const std::vector<uint8>& sendData,
	int32 recSize = -1
    );

    /// constructor for empty System Exclusive MIDI command 
    IOMidiSysExCmd(int32 recSize = -1);

    /// destructor
    virtual ~IOMidiSysExCmd();

    //---------------
    // set functions
    //---------------
    virtual void pushSendByte(uint8 byte) { txData.push_back(byte); }
    virtual void pushRecByte(uint8 byte) { rxData.push_back(byte); }

 protected:

 private:
};

END_NAMESPACE

#endif // !AH_IO_MIDI_SYS_EX_CMD_H
