//---------------------------------------------------------------------------
// Copyright 2005 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file `COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/libAHio/TestProfile.c,v $
// $Id: 
//
// Description: 
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: TestProfile.c,v 1.2 2005/02/11 18:52:44 ah Exp $ (c) 2005 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/IO/Profile.h>
USING_NAMESPACE(AH)

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <sstream>
#include <math.h>

USING_NAMESPACE(std)

// --- local defines ---

#define SPEED_BASE 3000  // processor clock cycle in MHz
 
// --- local implementation ---

static bool verbose = false;


static unsigned int test(unsigned int& testnum)
{
    unsigned int errnum = 0;

    // test constructor
    cout << "Test " << ++testnum << ": ";
    if (verbose) cout << "IOProfile(): ";
    IOProfile pr;
    cout << "done." << endl;

    // test getUserRunTime()
    cout << "Test " << ++testnum << ": ";
    if (verbose) cout << "IOProfile:getUserRunTime(): ";
    // make a loop which needs processing time:
    double tmp = 0;
    for (volatile int i = 0; i < 15000 * SPEED_BASE; ++i)
    {
	tmp += sqrt((double)i);
    }
    pr.catchNow();
    cout << pr.getUserRunTime() << endl;

    // test getSystemRunTime()
    cout << "Test " << ++testnum << ": ";
    if (verbose) cout << "IOProfile::getSystemRunTime(): ";
    // make a loop which needs processing time:
    for (volatile int i = 0; i < 70 * SPEED_BASE; ++i)
    {
	FILE* fp = fopen("/etc/fstab", "r");
	if (fp)
	{
	    fclose(fp);
	}
    }
    cout << pr.getSystemRunTime() << endl;

    // test getLastRunTime()
    cout << "Test " << ++testnum << ": ";
    if (verbose) cout << "IOProfile::getLastRunTime(): ";
    cout << pr.getLastRunTime() << endl;

    // test getRunTime()
    cout << "Test " << ++testnum << ": ";
    if (verbose) cout << "IOProfile::getRunTime(): ";
    cout << pr.getRunTime() << endl;


    return errnum;
}

//----------------------------------------------------------------------
// --- global implementation ---
//----------------------------------------------------------------------


int main(int argc, char* argv[])
{
    cout << "Test of class IOProfile:" << endl;

    if ((2 <= argc) && (0 == strcmp("-v", argv[1])))
	verbose = true;

    unsigned int errnum = 0;
    unsigned int testnum = 0;

    //-------------------------
    // test integer arguments:
    //-------------------------
    errnum += test(testnum);

    //----------------
    // print results:
    //----------------
    if (errnum)
	cout << "Stop. " << errnum << " error" 
	     << (errnum > 1 ? "s":"") << " found in " 
	     << testnum << " tests by " << argv[0] 
	     << "!" << endl;
    else
	cout << "Okay: no errors found in " << testnum << " tests." 
	     << endl;
    return (errnum ? 1 : 0);
}
