//---------------------------------------------------------------------------
// Copyright 2004 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file 'COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/libAHio/TimeStamp.c,v $
// $Id: TimeStamp.c,v 1.4 2005/01/21 21:28:49 ah Exp $ 
//
// Description: implementation of a profiling class
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: TimeStamp.c,v 1.4 2005/01/21 21:28:49 ah Exp $ (c) 2000 Andreas Huennebeck";

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
USING_NAMESPACE(AH)

#include <cstdio>
#include <cstdlib>
#include <unistd.h>
#include <sys/times.h>
//#include <ctime>
#include <string>
USING_NAMESPACE(std)

#include <AH/IO/TimeStamp.h>
USING_NAMESPACE(AH)

BEGIN_NAMESPACE(AH)

// --- local classes ---



// --- local constants ---

int IOTimeStamp::clock_tick = sysconf(_SC_CLK_TCK);

// --- local variables ---

// --- local classes ---

// --- local functions ---

// --- member functions ---

std::string IOTimeStamp::timeString(const std::string& name, double t)
{
    char buf[128];
    (void)sprintf(buf, "%s=%7.3fs", name.c_str(), t);
    return buf;
}

// --- global functions ---

IOTimeStamp IOTimeStamp::operator+ (const IOTimeStamp &that)
{
    IOTimeStamp sum;
    sum.stamp.tms_utime  = stamp.tms_utime  + that.stamp.tms_utime;
    sum.stamp.tms_stime  = stamp.tms_stime  + that.stamp.tms_stime;
//    sum.stamp.tms_cutime = stamp.tms_cutime + that.stamp.tms_cutime;
//    sum.stamp.tms_cstime = stamp.tms_cstime + that.stamp.tms_cstime;
    return sum;
}

IOTimeStamp IOTimeStamp::operator- (const IOTimeStamp &that)
{
    IOTimeStamp diff;
    diff.stamp.tms_utime  = stamp.tms_utime  - that.stamp.tms_utime;
    diff.stamp.tms_stime  = stamp.tms_stime  - that.stamp.tms_stime;
//    diff.stamp.tms_cutime = stamp.tms_cutime - that.stamp.tms_cutime;
//    diff.stamp.tms_cstime = stamp.tms_cstime - that.stamp.tms_cstime;
    return diff;
}

IOTimeStamp& IOTimeStamp::operator= (const IOTimeStamp &ts1)
{
    if (this != &ts1)
    {
	this->stamp.tms_utime  = ts1.stamp.tms_utime;
	this->stamp.tms_stime  = ts1.stamp.tms_stime;
//	this->stamp.tms_cutime = ts1.stamp.tms_cutime;
//	this->stamp.tms_cstime = ts1.stamp.tms_cstime;
    }
    return *this;
}

bool operator== (const IOTimeStamp &ts1, const IOTimeStamp &ts2)
{
    if (&ts1 == &ts2) return true;
    if (ts1.stamp.tms_utime != ts2.stamp.tms_utime) return false;
    if (ts1.stamp.tms_stime != ts2.stamp.tms_stime) return false;
//    if (ts1.stamp.tms_cutime != ts2.stamp.tms_cutime) return false;
//    if (ts1.stamp.tms_cstime != ts2.stamp.tms_cstime) return false;
    return true;
}

bool operator!= (const IOTimeStamp &ts1, const IOTimeStamp &ts2)
{
    if (&ts1 == &ts2) return false;
    if (ts1.stamp.tms_utime != ts2.stamp.tms_utime) return true;
    if (ts1.stamp.tms_stime != ts2.stamp.tms_stime) return true;
//    if (ts1.stamp.tms_cutime != ts2.stamp.tms_cutime) return true;
//    if (ts1.stamp.tms_cstime != ts2.stamp.tms_cstime) return true;
    return false;
}


END_NAMESPACE
// --- end of file ---

