/*
 *******************************************************************
 *
 * $Source: /bscl/CvsTree/bscl/gen/src/lib/libcb/localswap4.c,v $
 *
 * Copyright (c) 1995
 * BRUKER ANALYTISCHE MESSTECHNIK GMBH
 * D-76287 Rheinstetten, Germany
 *
 * All Rights Reserved
 *
 *
 * $Locker:  $
 * $State: Exp $
 * $Log: localswap4.c,v $
 * Revision 1.3  1995/12/21 16:24:48  ah
 * removed warnings caused by AllCWarnFlags.
 *
 * Revision 1.2  1995/07/12 15:02:38  ah
 * removed all other functions
 *
 * Revision 1.1  95/07/11  17:02:57  ah
 * Initial revision
 * 
 *
 *******************************************************************
 *	local_swap4() -	4 byte swap of memory content
 *
 *	Library:	/bscl/lib/libcb.a
 *	Source:		/bscl/src/lib/libcb/localswap4.c
 *	Documentation:	/bscl/docu/lib/libcb/localswap4.tex
 *
 *	Return Values:	none
 *
 *	Error Message:	none
 *******************************************************************
 */

#include <lib/libcb.h>

static const char rcsid[] = "$Header: /bscl/CvsTree/bscl/gen/src/lib/libcb/localswap4.c,v 1.3 1995/12/21 16:24:48 ah Exp $ (C) 1995 Bruker Analyt. Messt.";


/****************************************************************/
void local_swap4
(
    register void* ibuf,		/* buffer start address	*/
    const int  size,			/* buffer size in bytes	*/
    const int  endian			/* remote endian	*/
)
/****************************************************************/
{
    if( local_endian() != endian )
    {
	register char* buf = ibuf;
	register char* ebuf = buf + size; /* buffer end address	*/

	while ( buf < ebuf )
	{
	    register char c = buf[0];
	    buf[0] = buf[3];
	    buf[3] = c;
	    c      = buf[1];
	    buf[1] = buf[2];
	    buf[2] = c;
	    buf   += 4;
	}
    }
}
