//---------------------------------------------------------------------------
// Copyright 1998 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/libAHmath/NullSearchCreator.c,v $
// $Id: NullSearchCreator.c,v 1.3 2002/12/07 02:40:30 ah Exp $
//
// Description: implementation of class OpSearchCreator
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: NullSearchCreator.c,v 1.3 2002/12/07 02:40:30 ah Exp $ (c) 1998 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/Math/NullSearchCreator.h>
#include <AH/Math/RegulaFalsi.h>
#include <string.h>

USING_NAMESPACE(Ah)

// --- local stuff ---

// --- class member implementation ---

BEGIN_NAMESPACE(Ah)


NullSearch* NullSearchCreator::create
(
    double (*searchFunc)(double),
    const char* algo
) const
{
    if (!algo) return new RegulaFalsi(searchFunc);

    if (0 == strcmp(algo, "regula falsi"))
	return new RegulaFalsi(searchFunc);

    return 0;	// NullSearch not found

} // NullSearchCreator::create()


END_NAMESPACE
